using System;
using System.Numerics;

namespace Plazma
{
	class Program
	{
		static int Sum(int[] niz)
		{
			int s=0;
			for(int i=0;i<niz.Length;i++)
			{
				s+=niz[i];
			}
			return s;
		}
		public static void Main(string[] args)
		{
			int N=0,O=0;
			BigInteger brj=0;
			int u=0;
			string[] red1=Console.ReadLine().Split();
			N=int.Parse(red1[0]);
			O=int.Parse(red1[1]);
			BigInteger[] d=new BigInteger[N];
			BigInteger[] p=new BigInteger[N];
			BigInteger[] k=new BigInteger[O];
			for(int i=0;i<N;i++)
			{
				string[] red2=Console.ReadLine().Split();
				d[i]=BigInteger.Parse(red2[0]);
				p[i]=BigInteger.Parse(red2[1]);
			}
			for(int j=0;j<O;j++)
			{
				k[j]=BigInteger.Parse(Console.ReadLine());
			}
			for(int j=0;j<O;j++)
			{
				for(int i=int.Parse(d[0].ToString());i<=k[j];i++)
				{	
					if(u<N)
					{
						if(p[u]==brj && i==d[u+1] && u<N)
						{
							u++;
						}
						if(brj<p[u])
						{
							brj++;
						}
					}
					//Console.WriteLine(brj);
				}
				Console.WriteLine(brj);
			}
			Console.ReadKey(true);
		}
	}
}